import { Component, Input, Output, EventEmitter } from '@angular/core';
import { DataService } from 'src/services/data/data.service';

@Component({
  selector: 'character-card',
  templateUrl: './character-card.component.html',
  styleUrls: ['./character-card.component.scss'],
})
export class CharacterCardComponent {
  @Input() character: string = '';
  @Output() delete: EventEmitter<string> = new EventEmitter<string>();
  @Output() select: EventEmitter<string> = new EventEmitter<string>();
  public characterData: any = {};

  constructor(private dataAccessor: DataService) {}

  ngOnInit() {
    this.dataAccessor
      .getData(this.character, 'characterData')
      .then((characterData: any) => {
        this.characterData = characterData;
        console.log(this.characterData);
      });
  }

  public deleteCharacter(): void {
    this.delete.emit();
    // console.warn('Delete character: ' + this.character);
  }

  public selectCharacter(): void {
    this.select.emit();
    // console.warn('Select character: ' + this.character);
  }
}
